Index: branches/new_class_id/src/world_entities/weapons/fps_sniper_rifle.h
===================================================================
--- branches/new_class_id/src/world_entities/weapons/fps_sniper_rifle.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/fps_sniper_rifle.h	(revision 9709)
@@ -39,4 +39,6 @@
 class FPSSniperRifle : public Weapon
   {
+    NewObjectListDeclaration(FPSSniperRifle);
+
   public:
     FPSSniperRifle (int leftRight);
Index: branches/new_class_id/src/world_entities/weapons/hyperblaster.cc
===================================================================
--- branches/new_class_id/src/world_entities/weapons/hyperblaster.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/hyperblaster.cc	(revision 9709)
@@ -31,10 +31,11 @@
 #include "animation3d.h"
 
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 
 
 
-
-CREATE_FACTORY(Hyperblaster, CL_HYPERBLASTER);
+#include "class_id.h"
+NewObjectListDefinitionID(Hyperblaster, CL_HYPERBLASTER);
+CREATE_FACTORY(Hyperblaster);
 
 Hyperblaster::Hyperblaster(const TiXmlElement* root)
@@ -56,5 +57,5 @@
 void Hyperblaster::init()
 {
-  this->setClassID(CL_HYPERBLASTER, "Hyperblaster");
+  this->registerObject(this, Hyperblaster::_objectList);
 
 //  this->model = (Model*)ResourceManager::getInstance()->load("models/guns/test_gun.obj", OBJ, RP_CAMPAIGN);
@@ -76,5 +77,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_DIRECTIONAL | WTYPE_HEAVY);
-  this->setProjectileType(CL_HYPERBLAST);
+  this->setProjectileTypeC("Hyperblast");
   this->prepareProjectiles(2);
 
Index: branches/new_class_id/src/world_entities/weapons/hyperblaster.h
===================================================================
--- branches/new_class_id/src/world_entities/weapons/hyperblaster.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/hyperblaster.h	(revision 9709)
@@ -12,5 +12,6 @@
 class Hyperblaster : public Weapon
   {
-  public:
+    NewObjectListDeclaration(Hyperblaster);
+    public:
     Hyperblaster (const TiXmlElement* root = NULL);
     virtual ~Hyperblaster ();
Index: branches/new_class_id/src/world_entities/weapons/laser_cannon.cc
===================================================================
--- branches/new_class_id/src/world_entities/weapons/laser_cannon.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/laser_cannon.cc	(revision 9709)
@@ -29,8 +29,9 @@
 #include "animation3d.h"
 
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 
-CREATE_FACTORY(LaserCannon, CL_LASER_CANNON);
-
+#include "class_id.h"
+NewObjectListDefinitionID(LaserCannon, CL_LASER_CANNON);
+CREATE_FACTORY(LaserCannon);
 
 LaserCannon::LaserCannon(const TiXmlElement* root)
@@ -52,5 +53,5 @@
 void LaserCannon::init()
 {
-  this->setClassID(CL_LASER_CANNON, "LaserCannon");
+  this->registerObject(this, LaserCannon::_objectList);
 
 //  this->model = (Model*)ResourceManager::getInstance()->load("models/guns/laser_cannon.obj", OBJ, RP_CAMPAIGN);
@@ -72,5 +73,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-  this->setProjectileType(CL_RAIL_PROJECTILE);
+  this->setProjectileTypeC("RailProjectile");
   this->prepareProjectiles(100);
   this->setEmissionPoint(Vector(2.8,0,0) * 5.0);
Index: branches/new_class_id/src/world_entities/weapons/laser_cannon.h
===================================================================
--- branches/new_class_id/src/world_entities/weapons/laser_cannon.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/laser_cannon.h	(revision 9709)
@@ -29,5 +29,6 @@
 class LaserCannon : public Weapon
   {
-  public:
+    NewObjectListDeclaration(LaserCannon);
+    public:
     LaserCannon (const TiXmlElement* root = NULL);
     virtual ~LaserCannon ();
Index: branches/new_class_id/src/world_entities/weapons/targeting_turret.cc
===================================================================
--- branches/new_class_id/src/world_entities/weapons/targeting_turret.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/targeting_turret.cc	(revision 9709)
@@ -26,5 +26,7 @@
 #include "util/loading/factory.h"
 
-CREATE_FACTORY(TargetingTurret, CL_TARGETING_TURRET);
+#include "class_id.h"
+NewObjectListDefinitionID(TargetingTurret, CL_TARGETING_TURRET);
+CREATE_FACTORY(TargetingTurret);
 
 
@@ -48,5 +50,5 @@
 void TargetingTurret::init()
 {
-  this->setClassID(CL_TARGETING_TURRET, "TargetingTurret");
+  this->registerObject(this, TargetingTurret::_objectList);
 
   Animation3D* animation1 = this->getAnimation(WS_ACTIVATING, this);
@@ -70,5 +72,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_TURRET);
-  this->setProjectileType(CL_GUIDED_MISSILE);
+  this->setProjectileTypeC("GuidedMissile");
 
 
Index: branches/new_class_id/src/world_entities/weapons/targeting_turret.h
===================================================================
--- branches/new_class_id/src/world_entities/weapons/targeting_turret.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/targeting_turret.h	(revision 9709)
@@ -12,4 +12,5 @@
 class TargetingTurret : public Weapon
 {
+  NewObjectListDeclaration(TargetingTurret);
 public:
   TargetingTurret(const TiXmlElement* root = NULL);
Index: branches/new_class_id/src/world_entities/weapons/test_gun.cc
===================================================================
--- branches/new_class_id/src/world_entities/weapons/test_gun.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/test_gun.cc	(revision 9709)
@@ -31,8 +31,9 @@
 #include "animation3d.h"
 
-#include "fast_factory.h"
-
-CREATE_FACTORY(TestGun, CL_TEST_GUN);
-
+#include "loading/fast_factory.h"
+
+#include "class_id.h"
+NewObjectListDefinitionID(TestGun, CL_TEST_GUN);
+CREATE_FACTORY(TestGun);
 /**
  *  standard constructor
@@ -109,6 +110,5 @@
 void TestGun::init()
 {
-  this->setClassID(CL_TEST_GUN, "TestGun");
-
+  this->registerObject(this, TestGun::_objectList);
 //  this->model = (Model*)ResourceManager::getInstance()->load("models/guns/test_gun.obj", OBJ, RP_CAMPAIGN);
 
@@ -129,5 +129,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-  this->setProjectileType(CL_LASER);
+  this->setProjectileTypeC("Laser");
   this->prepareProjectiles(100);
 
Index: branches/new_class_id/src/world_entities/weapons/test_gun.h
===================================================================
--- branches/new_class_id/src/world_entities/weapons/test_gun.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/test_gun.h	(revision 9709)
@@ -37,4 +37,5 @@
 class TestGun : public Weapon
   {
+    NewObjectListDeclaration(TestGun);
   public:
     TestGun (int leftRight);
Index: branches/new_class_id/src/world_entities/weapons/turret.cc
===================================================================
--- branches/new_class_id/src/world_entities/weapons/turret.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/turret.cc	(revision 9709)
@@ -27,7 +27,7 @@
 #include "util/loading/factory.h"
 
-CREATE_FACTORY(Turret, CL_TURRET);
-
-
+#include "class_id.h"
+NewObjectListDefinitionID(Turret, CL_TURRET);
+CREATE_FACTORY(Turret);
 
 /**
@@ -62,5 +62,5 @@
 void Turret::init()
 {
-  this->setClassID(CL_TURRET, "Turret");
+  this->registerObject(this, Turret::_objectList);
 
 
@@ -86,5 +86,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_TURRET);
-  this->setProjectileType(CL_ROCKET);
+  this->setProjectileTypeC("Rocket");
 
   this->loadModel("models/guns/turret1.obj");
Index: branches/new_class_id/src/world_entities/weapons/turret.h
===================================================================
--- branches/new_class_id/src/world_entities/weapons/turret.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/turret.h	(revision 9709)
@@ -11,4 +11,5 @@
 class Turret : public Weapon
   {
+    NewObjectListDeclaration(Turret);
   public:
     Turret ();
Index: branches/new_class_id/src/world_entities/weapons/weapon.cc
===================================================================
--- branches/new_class_id/src/world_entities/weapons/weapon.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/weapon.cc	(revision 9709)
@@ -21,5 +21,5 @@
 #include "weapon.h"
 
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 #include "world_entities/projectiles/projectile.h"
 
